# Class LayoutFocusTraversalPolicy

java.lang.Object
java.awt.FocusTraversalPolicy
javax.swing.InternalFrameFocusTraversalPolicy
javax.swing.SortingFocusTraversalPolicy
javax.swing.LayoutFocusTraversalPolicy

All Implemented Interfaces:
  `Serializable`

public class LayoutFocusTraversalPolicy extends SortingFocusTraversalPolicy implements Serializable
A SortingFocusTraversalPolicy which sorts Components based on their size, position, and orientation. Based on their size and position, Components are roughly categorized into rows and columns. For a Container with horizontal orientation, columns run left-to-right or right-to-left, and rows run top- to-bottom. For a Container with vertical orientation, columns run top-to- bottom and rows run left-to-right or right-to-left. See `ComponentOrientation` for more information. All columns in a row are fully traversed before proceeding to the next row.

Since:
  1.4
See Also:
  - `ComponentOrientation`

## Constructor Summary

Constructors
Constructor
Description
`LayoutFocusTraversalPolicy()`
Constructs a LayoutFocusTraversalPolicy.

## Method Summary

Modifier and Type
Method
Description
`protected boolean`
`accept(Component aComponent)`
Determines whether the specified `Component` is an acceptable choice as the new focus owner.
`Component`
`getComponentAfter(Container aContainer, Component aComponent)`
Returns the Component that should receive the focus after aComponent. aContainer must be a focus cycle root of aComponent.
`Component`
`getComponentBefore(Container aContainer, Component aComponent)`
Returns the Component that should receive the focus before aComponent. aContainer must be a focus cycle root of aComponent.
`Component`
`getFirstComponent(Container aContainer)`
Returns the first Component in the traversal cycle.
`Component`
`getLastComponent(Container aContainer)`
Returns the last Component in the traversal cycle.

### Methods declared in class SortingFocusTraversalPolicy

`getComparator, getDefaultComponent, getImplicitDownCycleTraversal, setComparator, setImplicitDownCycleTraversal`
Modifier and Type
Method
Description
`protected Comparator<? super Component>`
`getComparator()`
Returns the Comparator which will be used to sort the Components in a focus traversal cycle.
`Component`
`getDefaultComponent(Container aContainer)`
Returns the default Component to focus.
`boolean`
`getImplicitDownCycleTraversal()`
Returns whether this SortingFocusTraversalPolicy transfers focus down- cycle implicitly.
`protected void`
`setComparator(Comparator<? super Component> comparator)`
Sets the Comparator which will be used to sort the Components in a focus traversal cycle.
`void`
`setImplicitDownCycleTraversal(boolean implicitDownCycleTraversal)`
Sets whether this SortingFocusTraversalPolicy transfers focus down-cycle implicitly.

### Methods declared in class InternalFrameFocusTraversalPolicy

`getInitialComponent`
Modifier and Type
Method
Description
`Component`
`getInitialComponent(JInternalFrame frame)`
Returns the Component that should receive the focus when a JInternalFrame is selected for the first time.

### Methods declared in class FocusTraversalPolicy

`getInitialComponent`
Modifier and Type
Method
Description
`Component`
`getInitialComponent(Window window)`
Returns the Component that should receive the focus when a Window is made visible for the first time.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### LayoutFocusTraversalPolicy

public LayoutFocusTraversalPolicy()
Constructs a LayoutFocusTraversalPolicy.

## Method Details

### getComponentAfter

public Component getComponentAfter(Container aContainer, Component aComponent)
Returns the Component that should receive the focus after aComponent. aContainer must be a focus cycle root of aComponent.

By default, LayoutFocusTraversalPolicy implicitly transfers focus down- cycle. That is, during normal focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. This behavior can be disabled using the `setImplicitDownCycleTraversal` method.

If aContainer is focus traversal policy provider, the focus is always transferred down-cycle.

Overrides:
  `getComponentAfter` in class `SortingFocusTraversalPolicy`
Parameters:
  `aContainer` - a focus cycle root of aComponent or a focus traversal policy provider
  `aComponent` - a (possibly indirect) child of aContainer, or aContainer itself
Returns:
  the Component that should receive the focus after aComponent, or null if no suitable Component can be found
Throws:
  `IllegalArgumentException` - if aContainer is not a focus cycle root of aComponent or a focus traversal policy provider, or if either aContainer or aComponent is null

### getComponentBefore

public Component getComponentBefore(Container aContainer, Component aComponent)
Returns the Component that should receive the focus before aComponent. aContainer must be a focus cycle root of aComponent.

By default, LayoutFocusTraversalPolicy implicitly transfers focus down- cycle. That is, during normal focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. This behavior can be disabled using the `setImplicitDownCycleTraversal` method.

If aContainer is focus traversal policy provider, the focus is always transferred down-cycle.

Overrides:
  `getComponentBefore` in class `SortingFocusTraversalPolicy`
Parameters:
  `aContainer` - a focus cycle root of aComponent or a focus traversal policy provider
  `aComponent` - a (possibly indirect) child of aContainer, or aContainer itself
Returns:
  the Component that should receive the focus before aComponent, or null if no suitable Component can be found
Throws:
  `IllegalArgumentException` - if aContainer is not a focus cycle root of aComponent or a focus traversal policy provider, or if either aContainer or aComponent is null

### getFirstComponent

public Component getFirstComponent(Container aContainer)
Returns the first Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the forward direction.

Overrides:
  `getFirstComponent` in class `SortingFocusTraversalPolicy`
Parameters:
  `aContainer` - a focus cycle root of aComponent or a focus traversal policy provider whose first Component is to be returned
Returns:
  the first Component in the traversal cycle of aContainer, or null if no suitable Component can be found
Throws:
  `IllegalArgumentException` - if aContainer is null

### getLastComponent

public Component getLastComponent(Container aContainer)
Returns the last Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the reverse direction.

Overrides:
  `getLastComponent` in class `SortingFocusTraversalPolicy`
Parameters:
  `aContainer` - a focus cycle root of aComponent or a focus traversal policy provider whose last Component is to be returned
Returns:
  the last Component in the traversal cycle of aContainer, or null if no suitable Component can be found
Throws:
  `IllegalArgumentException` - if aContainer is null

### accept

protected boolean accept(Component aComponent)
Determines whether the specified `Component` is an acceptable choice as the new focus owner. This method performs the following sequence of operations:

1. Checks whether `aComponent` is visible, displayable, enabled, and focusable. If any of these properties is `false`, this method returns `false`.
2. If `aComponent` is an instance of `JTable`, returns `true`.
3. If `aComponent` is an instance of `JComboBox`, then returns the value of `aComponent.getUI().isFocusTraversable(aComponent)`.
4. If `aComponent` is a `JComponent` with a `JComponent.WHEN_FOCUSED` `InputMap` that is neither `null` nor empty, returns `true`.
5. Returns the value of `DefaultFocusTraversalPolicy.accept(aComponent)`.

Overrides:
  `accept` in class `SortingFocusTraversalPolicy`
Parameters:
  `aComponent` - the `Component` whose fitness as a focus owner is to be tested
Returns:
  `true` if `aComponent` is a valid choice for a focus owner; otherwise `false`
See Also:
  - `Component.isVisible()`
  - `Component.isDisplayable()`
  - `Component.isEnabled()`
  - `Component.isFocusable()`
  - `ComboBoxUI.isFocusTraversable(JComboBox)`
  - `JComponent.getInputMap(int)`
  - `DefaultFocusTraversalPolicy.accept(Component)`